<?php
// $Id: winlivesearch.search.inc,v 1.1.2.1 2008/03/16 06:24:45 mfb Exp $

/**
 * Submit search query and process search results.
 */
function winlivesearch_service($keys) {
  global $pager_page_array, $pager_total, $pager_total_items, $language;
  $limit = max(1, intval(variable_get('winlivesearch_limit', 15)));
  $page = isset($_GET['page']) ? $_GET['page'] : 0;
  $results = array();
  $keys = (variable_get('winlivesearch_query', '')) ? '('. $keys .') AND ('. variable_get('winlivesearch_query', '') .')' : $keys;
  try {
    $webservice = new SoapClient('http://soap.search.msn.com/webservices.asmx?wsdl', array('trace' => 1));
    if ($webservice) {
      $params = array(
        'Request' => array(
          'AppID' => variable_get('winlivesearch_appid', ''),
          'CultureInfo' => ((isset($language->language) && variable_get('winlivesearch_use_locale', 0)) ? $language->language : variable_get('winlivesearch_locale', 'en-US')),
          'Flags' => 'MarkQueryWords',
          'Query' => $keys,
          'Requests' => array(
            array(
              'Count' => $limit,
              'Offset' => $limit * $page,
              'ResultFields' => implode(' ', variable_get('winlivesearch_fields', array('Title', 'Description', 'Url', 'DisplayUrl', 'DateTime'))),
              'Source' => variable_get('winlivesearch_source', 'Web'),
            ),
          ), 
          'SafeSearch' => variable_get('winlivesearch_safesearch', 'Strict'),
        ),
      );
      $response = $webservice->Search($params);
      $search = array('/\x{e000}/u', '/\x{e001}/u');
      $replace = array('<strong>', '</strong>');
      // Just in case there's a XSS payload in a live search description, we run
      // check_plain().  Link and title are already filtered by l().
      $items = isset($response->Response->Responses->SourceResponse->Results->Result) ? $response->Response->Responses->SourceResponse->Results->Result : array();
      $items = is_array($items) ? $items : array($items);
      foreach ($items as $item) {
        $results[] = array(
          'link' => isset($item->Url) ? $item->Url : NULL,
          'snippet' => isset($item->Description) ? preg_replace($search, $replace, check_plain($item->Description)) : NULL,
          'title' => isset($item->Title) ? preg_replace($search, '', $item->Title) : NULL,
          'date' => isset($item->DateTime) ? gmmktime($item->DateTime->Hour, $item->DateTime->Minute, $item->DateTime->Second, $item->DateTime->Month, $item->DateTime->Day, $item->DateTime->Year) : NULL,
          'extra' => isset($item->DisplayUrl) ? array(str_replace(array('<p>', '</p>'), '', check_markup($item->DisplayUrl))) : NULL,
        );
      }
      $element = 0;
      $pager_page_array = explode(',', $page);
      $pager_total_items[$element] = min($response->Response->Responses->SourceResponse->Total, 1000);
      $pager_total[$element] = ceil($pager_total_items[$element] / $limit);
      $pager_page_array[$element] = max(0, min(intval($pager_page_array[$element]), intval($pager_total[$element]) - 1));
    }
  }
  catch (Exception $fault) {
    $message = 'Web service error: %detail. %faultstring.';
    $variables = array('%detail' => $fault->detail, '%faultstring' => $fault->faultstring);
    watchdog('winlivesearch',  $message, $variables, WATCHDOG_ERROR);
    drupal_set_message(t($message, $variables), 'error');
  }
  return $results;
}
